/*******************************************************************************
 *  Copyright 2017-2018 Centre for Development of Advanced Computing(C-DAC), Pune
 *  
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *  
 *   http://www.apache.org/licenses/LICENSE-2.0
 *  
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 *******************************************************************************/
package cdac.medinfo.sdk.dcm30_04.templates.cathlabclinicalreporttemplate;

import cdac.medinfo.sdk.dcm30_04.baselibs.ContentSequenceItem;
import cdac.medinfo.sdk.dcm30_04.enums.EnumContinuityOfContent;
import cdac.medinfo.sdk.dcm30_04.srtree.SRTree;
import cdac.medinfo.sdk.dcm30_04.templates.cid.CirculatorySupport_CID3553;
import cdac.medinfo.sdk.dcm30_04.templates.cid.ClopidogrelTiclopidineAdministration_CID3743;
import cdac.medinfo.sdk.dcm30_04.templates.cid.MedicationAdministrationLabVisit_CID3741;
import cdac.medinfo.sdk.dcm30_04.templates.cid.MedicationAdministrationPCI_CID3742;
import cdac.medinfo.sdk.dcm30_04.templates.cid.PercutaneousClosure_CID3747;
import cdac.medinfo.sdk.dcm30_04.templates.cid.PercutaneousEntry_CID3746;
import cdac.medinfo.sdk.dcm30_04.templates.cid.PerformingRoles_CID7453;
import cdac.medinfo.sdk.dcm30_04.templates.cid.ThrombolyticAdministration_CID3740;
import cdac.medinfo.sdk.dcm30_04.templates.cid.YesNo_CID230;
import cdac.medinfo.sdk.dcm30_04.templates.enums.EnumCodingSchemeDesignator;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CIDPercutaneousEntry;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CathProcedure;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_CirculatorySupport;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ClopidogrelTiclopidineAdministration;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MedicationAdministrationLabVisit;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_MedicationAdministrationPCI;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PercutaneousClosure;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PerformingRole;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_PurposeOfReferenceToObject;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_ThrombolyticAdministration;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_Unit;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cm.EnumCM_YesNo;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_CathProcedure;
import cdac.medinfo.sdk.dcm30_04.templates.enums.cv.EnumCV_Unit;
import cdac.medinfo.sdk.dcm30_04.templates.generaltemplates.Template;

/**
 * This class represents CathProcedure - TID3806
 */
public class CathProcedure_TID3806 extends Template
{
	/**
	 * Object of YesNo_CID230
	 */
	private YesNo_CID230 objYesNoCID230;

	/**
	 * Object of PerformingRoles_CID7453
	 */
	private PerformingRoles_CID7453 objPerformingRoles_CID7453;

	/**
	 * Object of ThrombolyticAdministration_CID3740
	 */
	private ThrombolyticAdministration_CID3740 objThrombolyticAdministrationCID3740;

	/**
	 * Object of MedicationAdministrationLabVisit_CID3741
	 */
	private MedicationAdministrationLabVisit_CID3741 objMedicationAdministrationLabVisitCID3741;

	/**
	 * Object of MedicationAdministrationPCI_CID3742
	 */
	private MedicationAdministrationPCI_CID3742 objMedicationAdministrationPCICID3742;

	/**
	 * Object of ClopidogrelTiclopidineAdministration_CID3743
	 */
	private ClopidogrelTiclopidineAdministration_CID3743 objClopidogrelTiclopidineAdministrationCID3743;

	/**
	 * Object of CirculatorySupport_CID3553
	 */
	private CirculatorySupport_CID3553 objCirculatorySupport_CID3553;

	/**
	 * Object of PercutaneousEntry_CID3746
	 */
	private PercutaneousEntry_CID3746 objPercutaneousEntryCID3746;

	/**
	 * Object of PercutaneousClosure_CID3747
	 */
	private PercutaneousClosure_CID3747 objPercutaneousClosureCID3747;

	/**
	 * Instantiates CathProcedure_TID3806 Template.
	 * @param objTree Object of SRTree.
	 */
	public CathProcedure_TID3806(SRTree objTree)
	{
		super(objTree);
	}

	/**
	 * Sets the value for Current Procedure Descriptions
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumContinuityOfContent Enumerated Value for ContinuityOfContent.
	 */
	public void setCurrentProcedureDescriptions(int[] arrPosition, EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CURRENT_PROCEDURE_DESCRIPTIONS.getValue();
		String strCodeValue = EnumCV_CathProcedure.CURRENT_PROCEDURE_DESCRIPTIONS_55111_9.getValue();
		String strCSD = EnumCodingSchemeDesignator.LN.getValue();

		/**
		 * Creating a node of Value Type UIDREF and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createContainer(arrPosition, strCodeMeaning, strCodeValue, strCSD, enumContinuityOfContent);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Procedure DateTime.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strProcedureDateTime String value for DateTime of Intervention
	 */
	public void setProcedureDateTime(int[] arrPosition, String strProcedureDateTime)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.PROCEDURE_DATETIME.getValue();
		String strCodeValue = EnumCV_CathProcedure.PROCEDURE_DATETIME_52.getValue();
		String strCSD = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type DATETIME and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createDateTimeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strProcedureDateTime);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Procedure Number in this admission
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strProcedureNumberInThisAdmission String value for ProcedureNumberInThisAdmission.
	 */
	public void setProcedureNumberInThisAdmission(int[] arrPosition, String strProcedureNumberInThisAdmission)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.PROCEDURE_NUMBER_IN_THIS_ADMISSION.getValue();
		String strCodeValue = EnumCV_CathProcedure.PROCEDURE_NUMBER_IN_THIS_ADMISSION_53.getValue();
		String strCSD = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strProcedureNumberInThisAdmission);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Procedure Description
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strProcedureDescription String value for ProcedureDescription.
	 */
	public void setProcedureDescription(int[] arrPosition, String strProcedureDescription)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.PROCEDURE_DESCRIPTION.getValue();
		String strCodeValue = EnumCV_CathProcedure.PROCEDURE_DESCRIPTION_121065.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strProcedureDescription);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets Cath Lab Procedure Log
	 * @param arrPosition position at which the node will get added in the tree.
	 * @param enumPurposeOfReferenceToObject Enum value for Purpose Of Reference To Object
	 * @param strReferencedSOPClassUID Referenced SOP Class UID
	 * @param strReferencedSOPInstanceUID Referenced SOP Instance UID
	 */
	public void setCathLabProcedureLog(int[] arrPosition, EnumCM_PurposeOfReferenceToObject enumPurposeOfReferenceToObject, String strReferencedSOPClassUID, String strReferencedSOPInstanceUID)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CATH_LAB_PROCEDURE_LOG.getValue();
		String strCodeValue = EnumCV_CathProcedure.CATH_LAB_PROCEDURE_LOG_121120.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type COMPOSITE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCompositeNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strReferencedSOPClassUID, strReferencedSOPInstanceUID);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Fluoroscopy Time.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setFluoroscopyTime(int[] arrPosition,String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCMForUnit = EnumCM_Unit.MIN.getValue();
		String strCVForUnit = EnumCV_Unit.MIN.getValue();
		String strCSDForUnit = EnumCodingSchemeDesignator.UCUM.getValue();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.FLUOROSCOPY_TIME.getValue();
		String strCodeValue = EnumCV_CathProcedure.FLUOROSCOPY_TIME_55.getValue();
		String strCSD = EnumCodingSchemeDesignator.NCDR.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,strCVForUnit,strCSDForUnit,"",strCMForUnit,"","","","");
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Dose Area Product.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param arrNumericValue String array for Numeric Value.
	 */
	public void setDoseAreaProduct(int[] arrPosition,String[] arrNumericValue)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCMForUnit = EnumCM_Unit.MGYCM2.getValue();
		String strCVForUnit = EnumCV_Unit.MGYCM2.getValue();
		String strCSDForUnit = EnumCodingSchemeDesignator.UCUM.getValue();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.DOSE_AREA_PRODUCT.getValue();
		String strCodeValue = EnumCV_CathProcedure.DOSE_AREA_PRODUCT_122130.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		ContentSequenceItem objContentSequenceItem = getSRTree().createNumNode(arrPosition,strCodeMeaning,strCodeValue,strCSD,arrNumericValue,strCVForUnit,strCSDForUnit,"",strCMForUnit,"","","","");
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Catheterization Operator.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strCatheterizationOperator String value for CatheterizationOperator
	 */
	public void setCatheterizationOperator(int[] arrPosition, String strCatheterizationOperator)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CATHETERIZATION_OPERATOR.getValue();
		String strCodeValue = EnumCV_CathProcedure.CATHETERIZATION_OPERATOR_76.getValue();
		String strCSD = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type PNAME and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createPnameNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strCatheterizationOperator);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Fellow.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strFellow String value for Fellow
	 */
	public void setFellow(int[] arrPosition, String strFellow)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.FELLOW.getValue();
		String strCodeValue = EnumCV_CathProcedure.FELLOW_121088.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type PNAME and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createPnameNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strFellow);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Performing Roles
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumPerformingRole Enum value for Performing Roles
	 * @param strPname String value for Performing Roles.
	 * @param strValue 
	 */
	public void setPerformingRoles(int[] arrPosition,EnumCM_PerformingRole enumPerformingRole, String strPname, String strValue)
	{
		if(null== this.objPerformingRoles_CID7453)
			this.objPerformingRoles_CID7453 = new PerformingRoles_CID7453();

		this.objPerformingRoles_CID7453.setPerformingRoles(enumPerformingRole);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = objPerformingRoles_CID7453.getCodeMeaning();
		String strCodeValue = objPerformingRoles_CID7453.getCodeValue();
		String strCSD = objPerformingRoles_CID7453.getCodingSchemeDesignator();
		String strSNOMEDCTID = objPerformingRoles_CID7453.getSNOMEDCTID();

		/**
		 * Creating a node of Value Type PNAME and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createPnameNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, "", "", "", "", strSNOMEDCTID, strValue);
		getSRTree().addChild(objContentSequenceItem);
		
	}

	/**
	 * Sets the value for PCI during this procedure.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumYesNo Enum value for Yes-No.
	 */
	public void setPCIDuringThisProcedure(int[] arrPosition, EnumCM_YesNo enumYesNo)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objYesNoCID230)
			this.objYesNoCID230 = new YesNo_CID230();
		this.objYesNoCID230.setYesNo(enumYesNo);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objYesNoCID230.getCodeMeaning();
		String strCV = this.objYesNoCID230.getCodeValue();
		String strCSD1 = this.objYesNoCID230.getCodingSchemeDesignator();
		String strSNOMEDCTID = objYesNoCID230.getSNOMEDCTID();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.PCI_DURING_THIS_PROCEDURE.getValue();
		String strCodeValue = EnumCV_CathProcedure.PCI_DURING_THIS_PROCEDURE_122129.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM,strSNOMEDCTID);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Medication Given
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumContinuityOfContent Enumerated Value for ContinuityOfContent.
	 */
	public void setMedicationGiven(int[] arrPosition, EnumContinuityOfContent enumContinuityOfContent)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.MEDICATION_GIVEN.getValue();
		String strCodeValue = EnumCV_CathProcedure.MEDICATION_GIVEN_F_04460.getValue();
		String strCSD = EnumCodingSchemeDesignator.SRT.getValue();

		/**
		 * Creating a node of Value Type UIDREF and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createContainer(arrPosition, strCodeMeaning, strCodeValue, strCSD, enumContinuityOfContent);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Thrombolytics.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumThrombolyticAdministration Enum value for ThrombolyticAdministration
	 */
	public void setThrombolytics(int[] arrPosition, EnumCM_ThrombolyticAdministration enumThrombolyticAdministration)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objThrombolyticAdministrationCID3740)
			this.objThrombolyticAdministrationCID3740 = new ThrombolyticAdministration_CID3740();
		this.objThrombolyticAdministrationCID3740.setThrombolyticAdministration(enumThrombolyticAdministration);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objThrombolyticAdministrationCID3740.getCodeMeaning();
		String strCV = this.objThrombolyticAdministrationCID3740.getCodeValue();
		String strCSD1 = this.objThrombolyticAdministrationCID3740.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.THROMBOLYTICS.getValue();
		String strCodeValue = EnumCV_CathProcedure.THROMBOLYTICS_57.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for IIb/IIIa Blockade.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumMedicationAdministrationLabVisit Enum value for ThrombolyticAdministration
	 */
	public void setIIbIIIaBlockade(int[] arrPosition, EnumCM_MedicationAdministrationLabVisit enumMedicationAdministrationLabVisit)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objMedicationAdministrationLabVisitCID3741)
			this.objMedicationAdministrationLabVisitCID3741 = new MedicationAdministrationLabVisit_CID3741();
		this.objMedicationAdministrationLabVisitCID3741.setMedicationAdministrationLabVisit(enumMedicationAdministrationLabVisit);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objMedicationAdministrationLabVisitCID3741.getCodeMeaning();
		String strCV = this.objMedicationAdministrationLabVisitCID3741.getCodeValue();
		String strCSD1 = this.objMedicationAdministrationLabVisitCID3741.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.IIB_IIIA_BLOCKADE.getValue();
		String strCodeValue = EnumCV_CathProcedure.IIB_IIIA_BLOCKADE_58.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Heparin.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumMedicationAdministrationPCI Enum value for MedicationAdministrationPCI
	 */
	public void setHeparin(int[] arrPosition, EnumCM_MedicationAdministrationPCI enumMedicationAdministrationPCI)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objMedicationAdministrationPCICID3742)
			this.objMedicationAdministrationPCICID3742 = new MedicationAdministrationPCI_CID3742();
		this.objMedicationAdministrationPCICID3742.setMedicationAdministrationPCI(enumMedicationAdministrationPCI);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objMedicationAdministrationPCICID3742.getCodeMeaning();
		String strCV = this.objMedicationAdministrationPCICID3742.getCodeValue();
		String strCSD1 = this.objMedicationAdministrationPCICID3742.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.IIB_IIIA_BLOCKADE.getValue();
		String strCodeValue = EnumCV_CathProcedure.IIB_IIIA_BLOCKADE_58.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Aspirin.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumMedicationAdministrationLabVisit Enum value for ThrombolyticAdministration
	 */
	public void setAspirin(int[] arrPosition, EnumCM_MedicationAdministrationLabVisit enumMedicationAdministrationLabVisit)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objMedicationAdministrationLabVisitCID3741)
			this.objMedicationAdministrationLabVisitCID3741 = new MedicationAdministrationLabVisit_CID3741();
		this.objMedicationAdministrationLabVisitCID3741.setMedicationAdministrationLabVisit(enumMedicationAdministrationLabVisit);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objMedicationAdministrationLabVisitCID3741.getCodeMeaning();
		String strCV = this.objMedicationAdministrationLabVisitCID3741.getCodeValue();
		String strCSD1 = this.objMedicationAdministrationLabVisitCID3741.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.ASPIRIN.getValue();
		String strCodeValue = EnumCV_CathProcedure.ASPIRIN_60.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Clopidogrel/Ticlopidine.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumClopidogrelTiclopidineAdministration Enum value for ClopidogrelTiclopidineAdministration
	 */
	public void setClopidogrelTiclopidine(int[] arrPosition, EnumCM_ClopidogrelTiclopidineAdministration enumClopidogrelTiclopidineAdministration)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objClopidogrelTiclopidineAdministrationCID3743)
			this.objClopidogrelTiclopidineAdministrationCID3743 = new ClopidogrelTiclopidineAdministration_CID3743();
		this.objClopidogrelTiclopidineAdministrationCID3743.setClopidogrelTiclopidineAdministration(enumClopidogrelTiclopidineAdministration);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objClopidogrelTiclopidineAdministrationCID3743.getCodeMeaning();
		String strCV = this.objClopidogrelTiclopidineAdministrationCID3743.getCodeValue();
		String strCSD1 = this.objClopidogrelTiclopidineAdministrationCID3743.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CLOPIDOGREL_TICLOPIDINE.getValue();
		String strCodeValue = EnumCV_CathProcedure.CLOPIDOGREL_TICLOPIDINE_61.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Drug administered
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param strDrugAdministered String value for DrugAdministered.
	 */
	public void setDrugAdministered(int[] arrPosition, String strDrugAdministered)
	{
		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.DRUG_ADMINISTERED.getValue();
		String strCodeValue = EnumCV_CathProcedure.DRUG_ADMINISTERED_122083.getValue();
		String strCSD = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type TEXT and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createTextNode(arrPosition, strCodeMeaning, strCodeValue, strCSD, strDrugAdministered);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for CirculatorySupport.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumCirculatorySupport Enum value for CirculatorySupport
	 */
	public void setCirculatorySupport(int[] arrPosition, EnumCM_CirculatorySupport enumCirculatorySupport)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objCirculatorySupport_CID3553)
			this.objCirculatorySupport_CID3553 = new CirculatorySupport_CID3553();
		this.objCirculatorySupport_CID3553.setCirculatorySupport(enumCirculatorySupport);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objCirculatorySupport_CID3553.getCodeMeaning();
		String strCV = this.objCirculatorySupport_CID3553.getCodeValue();
		String strCSD1 = this.objCirculatorySupport_CID3553.getCodingSchemeDesignator();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CIRCULATORY_SUPPORT.getValue();
		String strCodeValue = EnumCV_CathProcedure.CIRCULATORY_SUPPORT_122138.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.DCM.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, "", strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Percutaneous Entry Site.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumPercutaneousEntry Enum value for PercutaneousEntry
	 */
	public void setPercutaneousEntrySite(int[] arrPosition, EnumCM_CIDPercutaneousEntry enumPercutaneousEntry)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objPercutaneousEntryCID3746)
			this.objPercutaneousEntryCID3746 = new PercutaneousEntry_CID3746();
		this.objPercutaneousEntryCID3746.setPercutaneousEntry(enumPercutaneousEntry);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objPercutaneousEntryCID3746.getCodeMeaning();
		String strCV = this.objPercutaneousEntryCID3746.getCodeValue();
		String strCSD1 = this.objPercutaneousEntryCID3746.getCodingSchemeDesignator();
		String strCSV = this.objPercutaneousEntryCID3746.getCodingSchemeVersion();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.PERCUTANEOUS_ENTRY_SITE.getValue();
		String strCodeValue = EnumCV_CathProcedure.PERCUTANEOUS_ENTRY_SITE_74.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, strCSV, strCM);
		getSRTree().addChild(objContentSequenceItem);
	}

	/**
	 * Sets the value for Closure Device.
	 * @param arrPosition Identifier which shows the position of the node in the SR Tree.
	 * @param enumPercutaneousClosure Enum value for PercutaneousClosure
	 */
	public void setClosureDevice(int[] arrPosition, EnumCM_PercutaneousClosure enumPercutaneousClosure)
	{
		/**
		 * Sets the value for Primary Intervention Device.
		 */
		if(null== this.objPercutaneousClosureCID3747)
			this.objPercutaneousClosureCID3747 = new PercutaneousClosure_CID3747();
		this.objPercutaneousClosureCID3747.setPercutaneousClosure(enumPercutaneousClosure);

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCM = this.objPercutaneousClosureCID3747.getCodeMeaning();
		String strCV = this.objPercutaneousClosureCID3747.getCodeValue();
		String strCSD1 = this.objPercutaneousClosureCID3747.getCodingSchemeDesignator();
		String strCSV = this.objPercutaneousClosureCID3747.getCodingSchemeVersion();

		/**
		 * Retrieves the corresponding values of CodeMeaning,CodeValue and CodingSchemeDesignator.
		 */
		String strCodeMeaning = EnumCM_CathProcedure.CLOSURE_DEVICE.getValue();
		String strCodeValue = EnumCV_CathProcedure.CLOSURE_DEVICE_75.getValue();
		String strCSD2 = EnumCodingSchemeDesignator.NCDR.getValue();

		/**
		 * Creating a node of Value Type CODE and adding this node at specified identifier in the SR Tree.
		 */
		ContentSequenceItem objContentSequenceItem = getSRTree().createCodeNode(arrPosition, strCodeMeaning,strCodeValue , strCSD2, strCV, strCSD1, strCSV, strCM);
		getSRTree().addChild(objContentSequenceItem);
	}
}
